// игра канонир
#include <Adafruit_GFX.h>    // Core graphics library
#include <Adafruit_ST7735.h> // Hardware-specific library
#include <SPI.h>
#define TFT_CS     10
#define TFT_RST    9  
#define TFT_DC     8
 Adafruit_ST7735 tft = Adafruit_ST7735(TFT_CS,  TFT_DC, TFT_RST);
 
extern const unsigned char ris_0[];
extern const unsigned char ris_1[];
extern const unsigned char ris_2[];
extern const unsigned char ris_3[];
extern const unsigned char ris_4[];
long Yk=0;//переменная хранения моментов времени
long Yj=0;//переменная хранения моментов времени
int i=0;// счётчик-переменная хранения положения корабля
int k=1;//
byte tt=1;//переменная задающая скорость движения корабля
int X=20;//счётчик-переменная хранения положения ядра
byte Nk=0;//счётчик утопленных кораблей
byte Nj=0;//счётчик расхода ядер

void setup(void) {
  digitalWrite(2, HIGH);// включить подтягивающий резистор для кнопки 
  // Используйте этот инициализатор, если вы используете 1,8-дюймовый TFT
 tft.initR(INITR_BLACKTAB);   // initialize a ST7735S chip, black tab
 //
 while(digitalRead(2)==HIGH){
 drawBitmap_(0,0,ris_0,128,160,1);//заставка
 delay(300);
 drawBitmap_(0,0,ris_0,128,160,2);//заставка
 delay(300);
 }
 //
 tft.fillScreen(tft.Color565(0,55,255));// фон моря
 tft.fillRect(80,0,48,160,tft.Color565(0,255,255));//фон неба
 tft.fillRect(0,65,5,30,tft.Color565(0,0,0));tft.fillRect(0,75,20,10,tft.Color565(0,0,0));//пушка
for(int j=0;j<9;j++){drawBitmap_(5,8*j,ris_3,16,8,2);}//обойма ядер рисуется
//
 tft.setRotation(0);//ориентация экрана
delay(200); 
 }
void loop() {
  //
 if(millis()-Yk>7*tt){//гоняем кораблик - мишень вдоль горизонта 
 Yk=millis();i=i+k;if(k==1){drawBitmap_(80,i,ris_1,48,48,1);}if(k==-1){drawBitmap_(80,i,ris_2,48,48,1);}
 if(i==112){k=-1;tft.fillRect(X,75,16,8,tft.Color565(0,55,255));X=20;delay(500*tt);tt=random(2,8);}
 if(i==0){k=1;tft.fillRect(X,75,16,8,tft.Color565(0,55,255));X=20;delay(500*tt);tt=random(2,8);}
 }
 if(millis()-Yj>5&&X>=21&&X<=60){Yj=millis();drawBitmap_(X,75,ris_3,16,8,2);X=X+2;}//рисуем полёт ядра если был выстрел
 
 if(digitalRead(2)==LOW){//производим выстрел по нажатию кнопки
  Nj++;if(Nj>9){Nj=0;for(int j=0;j<9;j++){drawBitmap_(5,8*j,ris_3,16,8,2);}}tft.fillRect(5,8*Nj-8,16,8,tft.Color565(0,55,255));//расход обоймы ядер рисуем
  tft.fillRect(X,75,16,8,tft.Color565(0,55,255));X=21;delay(150);
  }
 
 if(X>60){//если ядро попало то рисуем обломки корабля, а если  долетело стираем его изображение
  tft.fillRect(X,75,16,8,tft.Color565(0,55,255));
  if(i>50&&i<60){drawBitmap_(80,i,ris_4,48,48,1);delay(1000);Nk++;if(Nk>4){Nk=0;tft.fillRect(8*Nk-8,105,80,48,tft.Color565(0,55,255));}drawBitmap_(8*Nk-8,105,ris_1,48,48,2);}X=20;//условие попадания в цель
  }
 //
}
/////////////////////////////////////////////////////////////////////
void drawBitmap_(int x,int y, const uint8_t *bitmap,int w,int h,byte pal) {//функция вывода 4-х цветного рисунка по координатам, заданного размера и выбранной палитры
if(x<0||x+w>128||y<0||y+h>160){return;} 
 tft.setAddrWindow(x,y,x+w-1,y+h-1);
 int i, j, byteWidth = (w + 7) / 8;
  uint8_t byte_r;uint8_t byte_g;uint8_t byte_b;
   //
  SPI.beginTransaction(SPISettings(8000000, MSBFIRST, SPI_MODE0));
  digitalWrite(TFT_DC, HIGH);
  digitalWrite(TFT_CS, LOW); 
 for(j=0; j<h; j++) {
    for(i=0; i<w; i++) {
      if(i & 7) {byte_r <<= 1;byte_g <<= 1;}
      else     { byte_r = pgm_read_byte(bitmap + j * byteWidth + i / 8);byte_g = pgm_read_byte(bitmap + (j+h) * byteWidth + i / 8);}
      if((byte_r&0x80)&&(byte_g&0x80))
      {if(pal==1){SPI.transfer(tft.Color565(50,50,50)>>8);SPI.transfer(tft.Color565(50,50,50));}if(pal==2){SPI.transfer(tft.Color565(0,0,0)>>8);SPI.transfer(tft.Color565(0,0,0));}}
      if(!(byte_r&0x80)&&!(byte_g&0x80))
      {if(pal==1){SPI.transfer(tft.Color565(0,255,255)>>8);SPI.transfer(tft.Color565(0,255,255));}if(pal==2){SPI.transfer(tft.Color565(0,55,255)>>8);SPI.transfer(tft.Color565(0,55,255));}}
      if((byte_r&0x80)&&!(byte_g&0x80))
      {if(pal==1){SPI.transfer(tft.Color565(255,0,0)>>8);SPI.transfer(tft.Color565(255,0,0));}if(pal==2){SPI.transfer(tft.Color565(255,100,0)>>8);SPI.transfer(tft.Color565(255,100,0));}}
      if(!(byte_r&0x80)&&(byte_g&0x80))
      {if(pal==1){SPI.transfer(tft.Color565(250,250,0)>>8);SPI.transfer(tft.Color565(250,250,0));}if(pal==2){SPI.transfer(tft.Color565(250,250,250)>>8);SPI.transfer(tft.Color565(250,250,250));}}
      
    }
  }
  digitalWrite(TFT_CS, HIGH);
  SPI.endTransaction();
 ///  
}
/////////////////////////////////////////////////////////////////////

