// РИСУНОК 3 бита на цвет
#include <Adafruit_GFX.h>    // Core graphics library
#include <Adafruit_ST7735.h> // Hardware-specific library
#include <SPI.h>
#define TFT_CS     10
#define TFT_RST    9  
#define TFT_DC     8
 Adafruit_ST7735 tft = Adafruit_ST7735(TFT_CS,  TFT_DC, TFT_RST);

extern const unsigned char ris_1[];


void setup(void) {
  // Используйте этот инициализатор, если вы используете 1,8-дюймовый TFT
 tft.initR(INITR_BLACKTAB);   // initialize a ST7735S chip, black tab
 tft.fillScreen(ST7735_BLACK);
 tft.setRotation(0);//ориентация экрана
 }
void loop() {
drawBitmap_(0,0,ris_1,128,160);
delay(2000);

 }
/////////////////////////////////////////////////////////////////////
void drawBitmap_(int x,int y, const uint8_t *bitmap,int w,int h) {
if(x<0||x+w>128||y<0||y+h>160){return;} 
 tft.setAddrWindow(x,y,x+w-1,y+h-1);
 int i, j, byteWidth = (w + 7) / 8;
  uint8_t byte_r;uint8_t byte_g;uint8_t byte_b;
 for(j=0; j<h; j++) {
    for(i=0; i<w; i++) {
      if(i & 7) {byte_r <<= 1;byte_g <<= 1;byte_b <<= 1;}
      else     { byte_r = pgm_read_byte(bitmap + j * byteWidth + i / 8);byte_g = pgm_read_byte(bitmap + (j+h) * byteWidth + i / 8);byte_b = pgm_read_byte(bitmap + (j+2*h) * byteWidth + i / 8);}
      if((byte_r&0x80)&&(byte_g&0x80)&&(byte_b&0x80)){tft.pushColor(tft.Color565(255,255,255));}
      if(!(byte_r&0x80)&&!(byte_g&0x80)&&!(byte_b&0x80)){tft.pushColor(tft.Color565(0,0,0));}
      if((byte_r&0x80)&&(byte_g&0x80)&&!(byte_b&0x80)){tft.pushColor(tft.Color565(255,255,0));}
      if((byte_r&0x80)&&!(byte_g&0x80)&&(byte_b&0x80)){tft.pushColor(tft.Color565(255,0,255));}
      if(!(byte_r&0x80)&&(byte_g&0x80)&&(byte_b&0x80)){tft.pushColor(tft.Color565(0,255,255));}
      if((byte_r&0x80)&&!(byte_g&0x80)&&!(byte_b&0x80)){tft.pushColor(tft.Color565(255,0,0));}
      if(!(byte_r&0x80)&&(byte_g&0x80)&&!(byte_b&0x80)){tft.pushColor(tft.Color565(0,255,0));}
      if(!(byte_r&0x80)&&!(byte_g&0x80)&&(byte_b&0x80)){tft.pushColor(tft.Color565(0,0,255));}
    }
  }
}
/////////////////////////////////////////////////////////////////////

