//РИСУНОК преобразование в контур (4 цвета в картинке)
#include <Adafruit_GFX.h>    // Core graphics library
#include <Adafruit_ST7735.h> // Hardware-specific library

#include <SPI.h>

#define TFT_CS     10
#define TFT_RST    9
#define TFT_DC     8

Adafruit_ST7735 tft = Adafruit_ST7735(TFT_CS,  TFT_DC, TFT_RST);

extern const unsigned char ris_1[];


void setup() {
  // put your setup code here, to run once:
  // Используйте этот инициализатор, если вы используете 1,8-дюймовый TFT
  tft.initR(INITR_BLACKTAB);   // initialize a ST7735S chip, black tab
  tft.fillScreen(ST7735_BLACK);
  tft.setRotation(0);//ориентация экрана

}

void loop() {
  
  drawBitmap_(0,0,ris_1,128,160,tft.Color565(255,255,255),tft.Color565(255,0,0),tft.Color565(0,0,0),tft.Color565(0,100,0));
  delay(200);
 drawBitmap_(0,0,ris_1,128,160,tft.Color565(255,255,0),tft.Color565(255,255,0),tft.Color565(0,0,0),tft.Color565(0,0,0));
  delay(200);
 }
/////////////////////////////////////////////////////////////////////////////////////////
void drawBitmap_(int x,int y, const uint8_t *bitmap,int16_t W ,int16_t H,const uint16_t color_1,const uint16_t color_2,const uint16_t color_3,const uint16_t color_4) {
 bool flag=true;// 
 if(x<0||x+W>128||y<0||y+H>160){return;} 
 unsigned char  lineBuf[W*2 ]; 
  int16_t i, j, byteWidth = (W + 7) / 8;
  uint8_t byte_;uint8_t byte_st;
  for (unsigned short j = 0; j < H; j++) {
    for (unsigned short i = 0; i < W; i++) {
      if(i & 7) {byte_ <<= 1;byte_st <<= 1;}
      else     { byte_   = pgm_read_byte(bitmap + j * byteWidth + i / 8);if(j>0){byte_st = pgm_read_byte(bitmap + (j-1) * byteWidth + i / 8);}}
     if(byte_ & 0x80)
     {
          if(flag||!(byte_st & 0x80)){lineBuf[i*2 ] =color_1/256 ; lineBuf[i * 2 + 1] =color_1%256 ;} // цвет контура левого верхнего плана
          else{lineBuf[i*2 ] =color_4/256 ; lineBuf[i * 2 + 1] =color_4%256 ;} //  цвет раскраски внутри контура
     flag=false;
        } else {
          if(!flag||byte_st & 0x80){ lineBuf[i*2 ] =color_2/256 ; lineBuf[i * 2 + 1] =color_2%256 ;} //цвет контура правого нижнего плана
          else{lineBuf[i*2 ] =color_3/256 ; lineBuf[i * 2 + 1] =color_3%256 ;} // цвет фона
      flag=true; 
        }
    }
    
    tft.setAddrWindow(x+0, y+j, x+W-1, y+j);
    ///
    SPI.beginTransaction(SPISettings(8000000, MSBFIRST, SPI_MODE0));
    digitalWrite(TFT_DC, HIGH);
    digitalWrite(TFT_CS, LOW);
    SPI.transfer(&lineBuf, 2*W);
    digitalWrite(TFT_CS, HIGH);
    SPI.endTransaction();
    ///
  }
  
}
//////////////////////////////////////////////////////////////////////////////////////

