// НАБОР КУБИКОВ 5 штук
#include <Adafruit_GFX.h>    // Core graphics library
#include <Adafruit_ST7735.h> // Hardware-specific library
#include <SPI.h>
#define TFT_CS     10
#define TFT_RST    9  
#define TFT_DC     8
 Adafruit_ST7735 tft = Adafruit_ST7735(TFT_CS,  TFT_DC, TFT_RST);
 
extern const unsigned char ris_0[];//КАРТИНКА ЗАСТАВКИ
extern const unsigned char ris_1[];//КАРТИНКИ ВЫПАВШИХ ГРАНЕЙ КУБИКА
extern const unsigned char ris_2[];
extern const unsigned char ris_3[];
extern const unsigned char ris_4[];
extern const unsigned char ris_5[];
extern const unsigned char ris_6[];
long Y=0;//

byte ku1=1;byte ku2=1;byte ku3=1;byte ku4=1;byte ku5=1;//
int fiks=0;//
////////////////////////////////////////////////////////////////////
void fillScreen_(const uint16_t (*COLor_5)(int &I,int &J)){
tft.setAddrWindow(0,0,127,159);
  SPI.beginTransaction(SPISettings(8000000, MSBFIRST, SPI_MODE0));
  digitalWrite(TFT_DC, HIGH);
  digitalWrite(TFT_CS, LOW);  
 for(int j1=0; j1<160; j1++) {
    for( int i1=0; i1<128; i1++) {
  SPI.transfer(COLor_5(i1,j1)>>8);SPI.transfer(COLor_5(i1,j1));     
    }
}
digitalWrite(TFT_CS, HIGH);
SPI.endTransaction();
}
/////////////////////////////////////////////////////////////////////
void setup(void) {
  // Используйте этот инициализатор, если вы используете 1,8-дюймовый TFT
 tft.initR(INITR_BLACKTAB);   // initialize a ST7735S chip, black tab
 tft.cp437(true);//для правильного отображения русского алфавита 
 tft.setRotation(0);//ориентация экрана
 digitalWrite(2, HIGH);// включить подтягивающий резистор для кнопки броска кубиков
zastavka();//заставка игры
//
while(digitalRead(2)==HIGH){//инструкция игры (для пропуска нажмите кнопку)
tft.setCursor(5, 5);  
drawtext("Комплект кубиков предназначен для игр в  покер и 1000.Кнопка  управляет броском выбранного набора  кубиков, потенциометр позволяет совершить фиксацию нужного набора.Красно-жёлтые кубики активны, зелёно-голубые нет. ",tft.Color565(255,255,255));
tft.setCursor(5, 110);  
drawtext(" Для продолжения     игры нажмите кнопку.        Удачи!",tft.Color565(0,255,0));
delay(50);
}
//
Y=millis(); 
fillScreen_(COL5);// функция фоновой раскраски экрана
}
void loop() {
 //выбор и фиксация кубиков 
  fiks=map(analogRead(A0),0,1023,0,31);
 //псевдослучайный перебор оставшихся кубиков по нажатию кнопки
 if(digitalRead(2)==LOW){//
 Y=millis(); 
 if((fiks%2)/1==0){ku1=random(1,7);}
 if((fiks%4)/2==0){ku2=random(1,7);}
 if((fiks%8)/4==0){ku3=random(1,7);}
 if((fiks%16)/8==0){ku4=random(1,7);}
 if((fiks%32)/16==0){ku5=random(1,7);}
 }
 otrisovka();
if(millis()-Y>20000){zastavka();Y=millis();}//условие периодического появления заставки (если не нужно - заккоментировать строку)

}
////////////////////////////////////////////////////////////
const uint8_t *fun(byte ku){
if(ku==1){return ris_1;}
if(ku==2){return ris_2;}
if(ku==3){return ris_3;}
if(ku==4){return ris_4;}
if(ku==5){return ris_5;}
if(ku==6){return ris_6;}  
}
////////////////////////////////////////////////////////////
void zastavka (){
 drawBitmap_(0,0,ris_0,128,160,COL111,COL2,COL3,COL4);//заставка игры
 delay(3000);
 fillScreen_(COL5);// функция фоновой раскраски экрана
 }
////////////////////////////////////////////////////////////////////
void otrisovka (){
if((fiks%2)/1==0){drawBitmap_(15,0,fun(ku1),48,48,COL1,COL2,COL3,COL4);}else{drawBitmap_(15,0,fun(ku1),48,48,COL11,COL2,COL3,COL4);}
if((fiks%4)/2==0){drawBitmap_(40,53,fun(ku2),48,48,COL1,COL2,COL3,COL4);}else{drawBitmap_(40,53,fun(ku2),48,48,COL11,COL2,COL3,COL4);}
if((fiks%8)/4==0){drawBitmap_(15,106,fun(ku3),48,48,COL1,COL2,COL3,COL4);}else{drawBitmap_(15,106,fun(ku3),48,48,COL11,COL2,COL3,COL4);}
if((fiks%16)/8==0){drawBitmap_(63,0,fun(ku4),48,48,COL1,COL2,COL3,COL4);}else{drawBitmap_(63,0,fun(ku4),48,48,COL11,COL2,COL3,COL4);}
if((fiks%32)/16==0){drawBitmap_(63,106,fun(ku5),48,48,COL1,COL2,COL3,COL4);}else{drawBitmap_(63,106,fun(ku5),48,48,COL11,COL2,COL3,COL4);}
 }
/////////////////////////////////////////////////////////////////////
void drawBitmap_(int x,int y, const uint8_t *bitmap,int w,int h,const uint16_t (*COLor_1)(int &I,int &J),const uint16_t (*COLor_2)(int &X,int &Y,int &I,int &J),const uint16_t (*COLor_3)(int &I,int &J),const uint16_t (*COLor_4)(int &I,int &J)) {
 bool flag=true;//  
 if(x<0||x+w>128||y<0||y+h>160){return;} 
 tft.setAddrWindow(x,y,x+w-1,y+h-1);
 int  byteWidth = (w + 7) / 8;
 uint8_t byte_;uint8_t byte_st=0;
 
   //
  SPI.beginTransaction(SPISettings(8000000, MSBFIRST, SPI_MODE0));
  digitalWrite(TFT_DC, HIGH);
  digitalWrite(TFT_CS, LOW); 
 for(int j=0; j<h; j++) {
    for( int i=0; i<w; i++) {
      if(i & 7) {byte_ <<= 1;byte_st <<= 1;}
      else     { byte_   = pgm_read_byte(bitmap + j * byteWidth + i / 8);if(j>0){byte_st = pgm_read_byte(bitmap + (j-1) * byteWidth + i / 8);}}
      if(byte_ & 0x80)
      {
     if(flag||!(byte_st & 0x80)){SPI.transfer(COLor_3(i,j)>>8);SPI.transfer(COLor_3(i,j));}//цвет контура левого верхнего плана    
     else { SPI.transfer(COLor_1(i,j)>>8);SPI.transfer(COLor_1(i,j));}// цвет раскраски внутри контура 
   
      flag=false;
      }
     else {
       if(!flag||byte_st & 0x80){SPI.transfer(COLor_4(i,j)>>8);SPI.transfer(COLor_4(i,j));}//цвет контура правого нижнего плана
       else {SPI.transfer(COLor_2(x,y,i,j)>>8);SPI.transfer(COLor_2(x,y,i,j));} // цвет фона
      flag=true;  
     }
    }
  
  }
  digitalWrite(TFT_CS, HIGH);
  SPI.endTransaction();
 ///  
}
//////////////////////////////////////////////////////////////////////
//варианты функций - раскрасок 
const uint16_t COL1(int &i,int &j){// 1 позиция в аргументах - цвет раскраски изображения внутри контура
return tft.Color565(255-j*4,i*3,0);   
}
const uint16_t COL11(int &i,int &j){// 1 позиция в аргументах - цвет раскраски изображения внутри контура
return tft.Color565(0,255-j*4,i*3);   
}
const uint16_t COL111(int &i,int &j){// 1 позиция в аргументах - цвет раскраски изображения внутри контура
return tft.Color565(255-j,i,0);   
}
const uint16_t COL2(int &x,int &y,int &i,int &j){// 2 позиция в аргументах -  цвет фона (имеет доп. аргументы - координаты рисунка)
return tft.Color565(180-(j+y),(j+y)/2,(i+x)); 
}
const uint16_t COL3(int &i,int &j){// 3 позиция в аргументах - цвет контура левого верхнего плана 
return tft.Color565(255,150,150);   
}
const uint16_t COL4(int &i,int &j){// 4 позиция в аргументах - цвет контура правого нижнего плана
return tft.Color565(0,0,0);    
}
const uint16_t COL5(int &i1,int &j1){// фоновая раскраска 
return tft.Color565(180-j1,j1/2,i1);   
}
/////////////////////////////////////////////////////////////////////
void drawtext(char *text, uint16_t color) {
  tft.setTextColor(color);
  tft.setTextSize(0);
  tft.setTextWrap(true);
  tft.print(utf8rus(text));
}
////////////////////////////////////////////////////////////////////
/* Функция перекодировки русских букв из UTF-8 в Win-1251 */
String utf8rus(String source)
{
  int i,k;
  String target;
  unsigned char n;
  char m[2] = { '0', '\0' };

  k = source.length(); i = 0;

  while (i < k) {
    n = source[i]; i++;

    if (n >= 0xC0) {
      switch (n) {
        case 0xD0: {
          n = source[i]; i++;
          if (n == 0x81) { n = 0xA8; break; }
          if (n >= 0x90 && n <= 0xBF) n = n + 0x30;
          break;
        }
        case 0xD1: {
          n = source[i]; i++;
          if (n == 0x91) { n = 0xB8; break; }
          if (n >= 0x80 && n <= 0x8F) n = n + 0x70;
          break;
        }
      }
    }
    m[0] = n; target = target + String(m);
  }
return target;
}
//////////////////////////////////////////////////////////////////
