// РИСУНОК и способы его раскраски
#include <Adafruit_GFX.h>    // Core graphics library
#include <Adafruit_ST7735.h> // Hardware-specific library
#include <SPI.h>
#define TFT_CS     10
#define TFT_RST    9  
#define TFT_DC     8
Adafruit_ST7735 tft = Adafruit_ST7735(TFT_CS,  TFT_DC, TFT_RST);
extern const unsigned char ris_1[];

void setup(void) {
  // Используйте этот инициализатор, если вы используете 1,8-дюймовый TFT
  tft.initR(INITR_BLACKTAB);   // initialize a ST7735S chip, black tab
 tft.fillScreen(ST7735_BLACK);
 tft.setRotation(0);//ориентация экрана
 }
void loop() {
 //демонстрация вариантов раскраски - 1 ВАРИАНТ вывода картинки
 
drawBitmap_(0,0,ris_1, 128,160,0);
delay(1000);//
drawBitmap_(0,0,ris_1, 128,160,1);
delay(2000);//
drawBitmap_(0,0,ris_1, 128,160,0);
delay(1000);//
drawBitmap_(0,0,ris_1, 128,160,2);
delay(2000);//
drawBitmap_(0,0,ris_1, 128,160,0);
delay(1000);//
drawBitmap_(0,0,ris_1, 128,160,3);
delay(2000);//
drawBitmap_(0,0,ris_1, 128,160,0);
delay(1000);//
drawBitmap_(0,0,ris_1, 128,160,4);
delay(2000);//
drawBitmap_(0,0,ris_1, 128,160,0);
delay(1000);//
drawBitmap_(0,0,ris_1, 128,160,5);
delay(2000);//
//демонстрация вариантов раскраски - 2 ВАРИАНТ  вывода картинки
drawBitmap_2(0,0,ris_1, 128,160,0);
delay(1000);//
drawBitmap_2(0,0,ris_1, 128,160,1);
delay(2000);//
drawBitmap_2(0,0,ris_1, 128,160,0);
delay(1000);//
drawBitmap_2(0,0,ris_1, 128,160,2);
delay(2000);//
drawBitmap_2(0,0,ris_1, 128,160,0);
delay(1000);//
drawBitmap_2(0,0,ris_1, 128,160,3);
delay(2000);//
drawBitmap_2(0,0,ris_1, 128,160,0);
delay(1000);//
drawBitmap_2(0,0,ris_1, 128,160,4);
delay(2000);//
drawBitmap_2(0,0,ris_1, 128,160,0);
delay(1000);//
drawBitmap_2(0,0,ris_1, 128,160,5);
delay(2000);//
}
/////////////////////////////////////////////////////////////////////////
void drawBitmap_(int x,int y, const uint8_t *bitmap,int16_t W ,int16_t H,byte raskraska) {
 if(x<0||x+W>128||y<0||y+H>160){return;} 
 unsigned char  lineBuf[W*2 ]; 
  int16_t i, j, byteWidth = (W + 7) / 8;
  uint8_t byte;
  uint8_t r=50*random(1,6);
  for (unsigned short j = 0; j < H; j++) {
    for (unsigned short i = 0; i < W; ++i) {
       if(i & 7) byte <<= 1;
      else      byte   = pgm_read_byte(bitmap + j * byteWidth + i / 8);
     if(byte & 0x80)
     {
      if(raskraska==0){lineBuf[i*2 ] =tft.Color565(255,255,255)/256;lineBuf[i*2+1 ] =tft.Color565(255,255,255)%256; }//задаём один цвет  
      if(raskraska==1){lineBuf[i*2 ] =tft.Color565((1.6)*(j%H),200-(200/W)*(i%W),(255/W)*(i%W))/256;lineBuf[i*2+1 ] =tft.Color565((1.6)*(j%H),200-(200/W)*(i%W),(255/W)*(i%W))%256;}//задаём зависимости градиентов цветов 
      if(raskraska==2||raskraska==4){
       if(i*i+j*j<10010&&j<=W){lineBuf[i*2 ] =tft.Color565(255,0,0)/256;lineBuf[i*2+1 ] =tft.Color565(255,0,0)%256; } // задаём условия цветных секторов
       else{ if(j<=H/2-5&&i>W/2-5){lineBuf[i*2 ] =tft.Color565(255,0,255)/256;lineBuf[i*2+1 ] =tft.Color565(255,0,255)%256;}
       else{ if(j>H/2-5&&i>W/2-5){lineBuf[i*2 ] =tft.Color565(0,150,255)/256;lineBuf[i*2+1 ] =tft.Color565(0,150,255)%256;}
       else{ if(j>H/2-5&&i<=W/2-5){lineBuf[i*2 ] =tft.Color565(0,255,0)/256;lineBuf[i*2+1 ] =tft.Color565(0,255,0)%256;}
       }
       }
       } 
       }
        if(raskraska==3){
      if(i%2==0||j%2==1){r=50*random(1,6);}//задаём условие пиксельного ассорти  
      lineBuf[i*2 ] =tft.Color565(r,175-0.6*r,0)/256;lineBuf[i*2+1 ] =tft.Color565(r,175-0.6*r,0)%256;
      }
      if(raskraska==5){//задаём чередование цветовых полос
      if(j%4==0){lineBuf[i*2 ] =tft.Color565(255,255,255)/256;lineBuf[i*2+1 ] =tft.Color565(255,255,255)%256;}
      else{if(j%4==1){lineBuf[i*2 ] =tft.Color565(0,255,0)/256;lineBuf[i*2+1 ] =tft.Color565(0,255,0)%256;}
      else{if(j%4==2){lineBuf[i*2 ] =tft.Color565(0,0,0)/256;lineBuf[i*2+1 ] =tft.Color565(0,0,0)%256;}
      else{if(j%4==3){lineBuf[i*2 ] =tft.Color565(0,255,0)/256;lineBuf[i*2+1 ] =tft.Color565(0,255,0)%256;}
      }
      }
      }
       }
        } else {
         if(raskraska==4){lineBuf[i*2 ] =tft.Color565((1.6)*(j%H),200-(200/W)*(i%W),(255/W)*(i%W))/256;lineBuf[i*2+1 ] =tft.Color565((1.6)*(j%H),200-(200/W)*(i%W),(255/W)*(i%W))%256;}else{lineBuf[i*2 ] =tft.Color565(0,0,0)/256;lineBuf[i*2+1 ] =tft.Color565(0,0,0)%256;}
        }
    }
    
    tft.setAddrWindow(x+0, y+j, x+W-1, y+j);
    ///
    SPI.beginTransaction(SPISettings(8000000, MSBFIRST, SPI_MODE0));
    digitalWrite(TFT_DC, HIGH);
    digitalWrite(TFT_CS, LOW);
    SPI.transfer(&lineBuf, 2*W);
    digitalWrite(TFT_CS, HIGH);
    SPI.endTransaction();
    ///
  }
  
}
////////////////////////////////////////////////////////
void drawBitmap_2(int16_t x, int16_t y,
 const uint8_t *bitmap, int16_t w, int16_t h,byte raskraska) {
 int16_t i, j, byteWidth = (w + 7) / 8;
  uint8_t byte;
 if(x<0||x+w>128||y<0||y+h>160){return;} 
 tft.setAddrWindow(x,y,x+w-1,y+h-1);//задаём область вывода данных
  uint8_t r=50*random(1,6);
  for(j=0; j<h; j++) {
    for(i=0; i<w; i++) {
      if(i & 7) byte <<= 1;
      else      byte   = pgm_read_byte(bitmap + j * byteWidth + i / 8);
      if(byte & 0x80)
      {
      if(raskraska==0){tft.pushColor(tft.Color565(255,255,255) );}//задаём один цвет  
      if(raskraska==1){tft.pushColor(tft.Color565((1.6)*(j%h),200-(200/w)*(i%w),(255/w)*(i%w)));}//задаём зависимости градиентов цветов 
      if(raskraska==2||raskraska==4){
       if(i*i+j*j<10010&&j<=w){tft.pushColor(tft.Color565(255,0,0) );} // задаём условия цветных секторов
       else{ if(j<=h/2-5&&i>w/2-5){tft.pushColor(tft.Color565(255,0,255) );}
       else{ if(j>h/2-5&&i>w/2-5){tft.pushColor(tft.Color565(0,150,255) );}
       else{ if(j>h/2-5&&i<=w/2-5){tft.pushColor(tft.Color565(0,255,0) );}
       }
       }
       } 
       }
        if(raskraska==3){
      if(i%2==0||j%2==1){r=50*random(1,6);}//задаём условие пиксельного ассорти  
      tft.pushColor(tft.Color565(r,175-0.6*r,0));
      }
      if(raskraska==5){//задаём один цвет
     tft.pushColor(tft.Color565(0,0,0));
       }
      }
     else {
      if(raskraska==4){tft.pushColor(tft.Color565((1.6)*(j%h),200-(200/w)*(i%w),(255/w)*(i%w)));}else{}
      if(raskraska==5){//задаём чередование цветовых полос в фоновой части рисунка
      if(j%4==0){tft.pushColor(tft.Color565(255,255,255));}
      else{if(j%4==1){tft.pushColor(tft.Color565(0,255,0));}
      else{if(j%4==2){tft.pushColor(tft.Color565(0,0,0));}
      else{if(j%4==3){tft.pushColor(tft.Color565(0,255,0));}
      }
      }
      }
       }
       if(raskraska!=4&&raskraska!=5){tft.pushColor(tft.Color565(0,0,0));}//
      }
    }
  }
}
//////////////////////////////////////////////////////////
