// РИСУНОК контур 4 цвета
#include <Adafruit_GFX.h>    // Core graphics library
#include <Adafruit_ST7735.h> // Hardware-specific library
#include <SPI.h>
#define TFT_CS     10
#define TFT_RST    9  
#define TFT_DC     8
 Adafruit_ST7735 tft = Adafruit_ST7735(TFT_CS,  TFT_DC, TFT_RST);

extern const unsigned char ris_3[];


void setup(void) {
  // Используйте этот инициализатор, если вы используете 1,8-дюймовый TFT
 tft.initR(INITR_BLACKTAB);   // initialize a ST7735S chip, black tab
 tft.fillScreen(ST7735_BLACK);
 tft.setRotation(0);//ориентация экрана
 }
void loop() {

drawBitmap_(0,0,ris_3,128,160,tft.Color565(0,175,175),tft.Color565(0,155,155),tft.Color565(255,255,255),tft.Color565(0,0,0));
delay(2000);
 }
/////////////////////////////////////////////////////////////////////
void drawBitmap_(int x,int y, const uint8_t *bitmap,int w,int h,const uint16_t color_1,const uint16_t color_2,const uint16_t color_3,const uint16_t color_4) {
 bool flag=true;//  
 if(x<0||x+w>128||y<0||y+h>160){return;} 
 tft.setAddrWindow(x,y,x+w-1,y+h-1);
byte D;

 int i, j, byteWidth = (w + 7) / 8;
  uint8_t byte_;uint8_t byte_st;
 for(j=0; j<h; j++) {
    for(i=0; i<w; i++) {
      if(i & 7) {byte_ <<= 1;byte_st <<= 1;}
      else     { byte_   = pgm_read_byte(bitmap + j * byteWidth + i / 8);if(j>0){byte_st = pgm_read_byte(bitmap + (j-1) * byteWidth + i / 8);}}
      if(byte_ & 0x80)
      {
     if(flag||!(byte_st & 0x80)){tft.pushColor(color_3 );}//цвет контура левого верхнего плана    
    // else {tft.pushColor(color_1);}// цвет раскраски внутри контура 
     else {tft.pushColor(tft.Color565(0,255-j,255-j) );}
      flag=false;
      }
     else {
       if(!flag||byte_st & 0x80){tft.pushColor(color_4 );}//цвет контура правого нижнего плана
      // else {tft.pushColor(color_2);}// цвет фона
       else {tft.pushColor(tft.Color565(0,235-j,235-j));}
      flag=true;  
     }
    }
  }
}
/////////////////////////////////////////////////////////////////////

