// РИСУНОК контур 4 цвета
#include <Adafruit_GFX.h>    // Core graphics library
#include <Adafruit_ST7735.h> // Hardware-specific library
#include <SPI.h>
#define TFT_CS     10
#define TFT_RST    9  
#define TFT_DC     8
 Adafruit_ST7735 tft = Adafruit_ST7735(TFT_CS,  TFT_DC, TFT_RST);

extern const unsigned char ris_1[];


void setup(void) {
  // Используйте этот инициализатор, если вы используете 1,8-дюймовый TFT
 tft.initR(INITR_BLACKTAB);   // initialize a ST7735S chip, black tab
 tft.fillScreen(ST7735_BLACK);
 tft.setRotation(0);//ориентация экрана
 }
void loop() {
drawBitmap_(0,0,ris_1,128,160,COL1,COL2,COL3,COL4);
delay(500);

 }
/////////////////////////////////////////////////////////////////////
void drawBitmap_(int x,int y, const uint8_t *bitmap,int w,int h,const uint16_t (*COLor_1)(int &I,int &J),const uint16_t (*COLor_2)(int &I,int &J),const uint16_t (*COLor_3)(int &I,int &J),const uint16_t (*COLor_4)(int &I,int &J)) {
 bool flag=true;//  
 if(x<0||x+w>128||y<0||y+h>160){return;} 
 tft.setAddrWindow(x,y,x+w-1,y+h-1);
 int  byteWidth = (w + 7) / 8;
 uint8_t byte_;uint8_t byte_st;
 
   //
  SPI.beginTransaction(SPISettings(8000000, MSBFIRST, SPI_MODE0));
  digitalWrite(TFT_DC, HIGH);
  digitalWrite(TFT_CS, LOW); 
 for(int j=0; j<h; j++) {
    for( int i=0; i<w; i++) {
      if(i & 7) {byte_ <<= 1;byte_st <<= 1;}
      else     { byte_   = pgm_read_byte(bitmap + j * byteWidth + i / 8);if(j>0){byte_st = pgm_read_byte(bitmap + (j-1) * byteWidth + i / 8);}}
      if(byte_ & 0x80)
      {
     if(flag||!(byte_st & 0x80)){SPI.transfer(COLor_3(i,j)>>8);SPI.transfer(COLor_3(i,j));}//цвет контура левого верхнего плана    
     else { SPI.transfer(COLor_1(i,j)>>8);SPI.transfer(COLor_1(i,j));}// цвет раскраски внутри контура 
   
      flag=false;
      }
     else {
       if(!flag||byte_st & 0x80){SPI.transfer(COLor_4(i,j)>>8);SPI.transfer(COLor_4(i,j));}//цвет контура правого нижнего плана
       else {SPI.transfer(COLor_2(i,j)>>8);SPI.transfer(COLor_2(i,j));} // цвет фона
      flag=true;  
     }
    }
  }
  digitalWrite(TFT_CS, HIGH);
  SPI.endTransaction();
 ///  
}
/////////////////////////////////////////////////////////////////////
//варианты функций - раскрасок
const uint16_t COL1(int &i,int &j){// 1 позиция в аргументах - цвет раскраски изображения внутри контура
return tft.Color565(255-j/2,190-j,0);   
}
const uint16_t COL2(int &i,int &j){// 2 позиция в аргументах -  цвет фона
return tft.Color565(225-i/2,160-i,0);
//return tft.Color565(255,255,0)<<((j+4*i)%15);
}
const uint16_t COL3(int &i,int &j){// 3 позиция в аргументах - цвет контура левого верхнего плана 
return tft.Color565(200,200,100);   
}
const uint16_t COL4(int &i,int &j){// 4 позиция в аргументах - цвет контура правого нижнего плана
return tft.Color565(75,75,75);   
}
/////////////////////////////////////////////////////////////////////
